/*
 * generated by Fujaba - CodeGen2
 */
package dpexamples.model;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class AdressBook
{

   /**
    * <pre>
    *           0..1     entries     0..n
    * AdressBook ------------------------- Entry
    *           adressBook2               entries2
    * </pre>
    */
   public static final String PROPERTY_ENTRIES2 = "entries2";

   @Property( name = PROPERTY_ENTRIES2, partner = Entry.PROPERTY_ADRESS_BOOK2, kind = ReferenceHandler.ReferenceKind.QUALIFIED_TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FDuplicatedHashMap entries2;

   @Property( name = PROPERTY_ENTRIES2 )
   public boolean addToEntries2 (Entry value)
   {
      return this.addToEntries2 (getKeyForEntries2 (value), value);
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public boolean removeFromEntries2 (Entry value)
   {
      return removeFromEntries2 (getKeyForEntries2 (value), value);
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public void removeAllFromEntries2 ()
   {
   
      Iterator iter = entriesOfEntries2 ();
      Map.Entry entry;
      while (iter.hasNext ())
      {
         entry = (Map.Entry) iter.next ();
         removeFromEntries2 ((String) entry.getKey (), (Entry) entry.getValue ());
      }
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public boolean hasInEntries2 (Entry value)
   {
      return (this.hasInEntries2 (this.getKeyForEntries2 (value), value));
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public Iterator iteratorOfEntries2 ()
   {
      return ((this.entries2 == null)
              ? FEmptyIterator.get ()
              : this.entries2.values ().iterator ());
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public int sizeOfEntries2 ()
   {
      return ((this.entries2 == null)
              ? 0
              : this.entries2.size ());
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public boolean hasInEntries2 (String key, Entry value)
   {
      return ((this.entries2 != null) &&
              this.entries2.containsEntry (key, value));
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public boolean hasKeyInEntries2 (String key)
   {
      return ((this.entries2 != null) &&
              this.entries2.containsKey (key));
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public Iterator keysOfEntries2 ()
   {
      return ((this.entries2 == null)
              ? FEmptyIterator.get ()
              : this.entries2.keySet ().iterator ());
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public Iterator entriesOfEntries2 ()
   {
      return ((this.entries2 == null)
              ? FEmptyIterator.get ()
              : this.entries2.entrySet ().iterator ());
   }

   @Property( name = PROPERTY_ENTRIES2 )
   protected boolean addToEntries2 (String key, Entry value)
   {
      boolean changed = false;

      if (this.entries2 == null)
      {
         this.entries2 = new FDuplicatedHashMap ();
      }
   
      Entry oldValue = (Entry) this.entries2.put (key, value);
      if (oldValue != value)
      {
         if (oldValue != null)
         {
            oldValue.setAdressBook2 (null);
         }
         if (value != null)
         {
            value.setAdressBook2 (this);
         }
         changed = true;
      }
   
      return changed;
   }

   @Property( name = PROPERTY_ENTRIES2 )
   protected boolean addToEntries2 (Map.Entry entry)
   {
      return addToEntries2 ((String) entry.getKey (), (Entry) entry.getValue ());
   }

   @Property( name = PROPERTY_ENTRIES2 )
   protected boolean removeFromEntries2 (String key, Entry value)
   {
      boolean changed = false;

      if ((this.entries2 != null) &&
          (value != null || this.entries2.containsEntry (key, value)))
      {
      
         Entry oldValue  = (Entry) this.entries2.remove (key, value);
         if (oldValue == value)
         {
           if (value != null)
           {
              value.setAdressBook2 (null);
           }
           changed = true;
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public boolean removeKeyFromEntries2 (String key)
   {
      boolean changed = false;

      if (this.entries2 != null)
      {
      
         Collection tmpCol = (Collection) this.entries2.values (key);
         if (tmpCol != null)
         {
            Entry tmpValue;
            Iterator iter = tmpCol.iterator ();
            while (iter.hasNext ())
            {
               tmpValue = (Entry) iter.next ();
               this.removeFromEntries2 (key, tmpValue);
            }
            changed = true;
         }
      
      }
      return changed;
   }
   @Property( name = PROPERTY_ENTRIES2 )
   public Iterator iteratorOfEntries2 (String key)
   {
      return ((this.entries2 == null)
              ? FEmptyIterator.get ()
              : FCollections.iterator (this.entries2.values (key)));
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public int sizeOfEntries2 (String key)
   {
      return ((this.entries2 == null)
              ? 0
              : this.entries2.size (key));
   }
   @Property( name = PROPERTY_ENTRIES2 )
   public String getKeyForEntries2 (Entry value)
   {
      return (value == null ? null : value.getName ());
   }

   @Property( name = PROPERTY_ENTRIES2 )
   public void keyChangedInEntries2 (String oldKey, Entry value)
   {
      if ((this.entries2 != null) && 
          (oldKey != getKeyForEntries2 (value)))
      {
         Entry oldValue  = (Entry) this.entries2.remove (oldKey, value);
         if (oldValue != null)
         {
            this.entries2.put (getKeyForEntries2 (value), value);
         }
      }
   }

   /**
    * <pre>
    *           0..1     adressBook     0..1
    * AdressBook ------------------------- MobilePhone
    *           adressBook               mobilePhone
    * </pre>
    */
   public static final String PROPERTY_MOBILE_PHONE = "mobilePhone";

   @Property( name = PROPERTY_MOBILE_PHONE, partner = MobilePhone.PROPERTY_ADRESS_BOOK, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private MobilePhone mobilePhone;

   @Property( name = PROPERTY_MOBILE_PHONE )
   public boolean setMobilePhone (MobilePhone value)
   {
      boolean changed = false;

      if (this.mobilePhone != value)
      {
      
         MobilePhone oldValue = this.mobilePhone;
         AdressBook source = this;
         if (this.mobilePhone != null)
         {
            this.mobilePhone = null;
            oldValue.setAdressBook (null);
         }
         this.mobilePhone = value;

         if (value != null)
         {
            value.setAdressBook (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_MOBILE_PHONE )
   public MobilePhone getMobilePhone ()
   {
      return this.mobilePhone;
   }

   public void removeYou()
   {
      this.removeAllFromEntries2 ();
      this.setMobilePhone (null);
   }
}


