/*
 * generated by Fujaba - CodeGen2
 */
package dpexamples.model;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import de.upb.tools.sdm.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Company
{

   /**
    * <pre>
    *           0..1     contains     0..n
    * Company ------------------------- Employee
    *           company               employees
    * </pre>
    */
   public static final String PROPERTY_EMPLOYEES = "employees";

   @Property( name = PROPERTY_EMPLOYEES, partner = Employee.PROPERTY_COMPANY, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet employees;

   @Property( name = PROPERTY_EMPLOYEES )
   public boolean addToEmployees (Employee value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.employees == null)
         {
            this.employees = new FHashSet ();

         }
      
         changed = this.employees.add (value);
         if (changed)
         {
            value.setCompany (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_EMPLOYEES )
   public boolean removeFromEmployees (Employee value)
   {
      boolean changed = false;

      if ((this.employees != null) && (value != null))
      {
      
         changed = this.employees.remove (value);
         if (changed)
         {
            value.setCompany (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_EMPLOYEES )
   public void removeAllFromEmployees ()
   {
   
      Employee tmpValue;
      Iterator iter = this.iteratorOfEmployees ();

      while (iter.hasNext ())
      {
         tmpValue = (Employee) iter.next ();
         this.removeFromEmployees (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_EMPLOYEES )
   public boolean hasInEmployees (Employee value)
   {
      return ((this.employees != null) &&
              (value != null) &&
              this.employees.contains (value));
   }

   @Property( name = PROPERTY_EMPLOYEES )
   public Iterator iteratorOfEmployees ()
   {
      return ((this.employees == null)
              ? FEmptyIterator.get ()
              : this.employees.iterator ());
   }

   @Property( name = PROPERTY_EMPLOYEES )
   public int sizeOfEmployees ()
   {
      return ((this.employees == null)
              ? 0
              : this.employees.size ());
   }

   /**
    * <pre>
    *           0..1     managers     0..n
    * Company ------------------------- Manager
    *           world               managers
    * </pre>
    */
   public static final String PROPERTY_MANAGERS = "managers";

   @Property( name = PROPERTY_MANAGERS, partner = Manager.PROPERTY_WORLD, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet managers;

   @Property( name = PROPERTY_MANAGERS )
   public boolean addToManagers (Manager value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.managers == null)
         {
            this.managers = new FHashSet ();

         }
      
         changed = this.managers.add (value);
         if (changed)
         {
            value.setWorld (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_MANAGERS )
   public boolean removeFromManagers (Manager value)
   {
      boolean changed = false;

      if ((this.managers != null) && (value != null))
      {
      
         changed = this.managers.remove (value);
         if (changed)
         {
            value.setWorld (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_MANAGERS )
   public void removeAllFromManagers ()
   {
   
      Manager tmpValue;
      Iterator iter = this.iteratorOfManagers ();

      while (iter.hasNext ())
      {
         tmpValue = (Manager) iter.next ();
         this.removeFromManagers (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_MANAGERS )
   public boolean hasInManagers (Manager value)
   {
      return ((this.managers != null) &&
              (value != null) &&
              this.managers.contains (value));
   }

   @Property( name = PROPERTY_MANAGERS )
   public Iterator iteratorOfManagers ()
   {
      return ((this.managers == null)
              ? FEmptyIterator.get ()
              : this.managers.iterator ());
   }

   @Property( name = PROPERTY_MANAGERS )
   public int sizeOfManagers ()
   {
      return ((this.managers == null)
              ? 0
              : this.managers.size ());
   }

   /**
    * <pre>
    *           0..1     project     0..1
    * Company ------------------------- Project
    *           company               project
    * </pre>
    */
   public static final String PROPERTY_PROJECT = "project";

   @Property( name = PROPERTY_PROJECT, partner = Project.PROPERTY_COMPANY, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Project project;

   @Property( name = PROPERTY_PROJECT )
   public boolean setProject (Project value)
   {
      boolean changed = false;

      if (this.project != value)
      {
      
         Project oldValue = this.project;
         Company source = this;
         if (this.project != null)
         {
            this.project = null;
            oldValue.setCompany (null);
         }
         this.project = value;

         if (value != null)
         {
            value.setCompany (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PROJECT )
   public Project getProject ()
   {
      return this.project;
   }

   public void run ()
   {
      boolean fujaba__Success = false;
      Iterator fujaba__IterThisToE = null;
      Employee e = null;
      Iterator fujaba__IterPrToT = null;
      Task t = null;
      Project pr = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // search to-one link project from this to pr
         pr = this.getProject ();

         // check object pr is really bound
         JavaSDM.ensure ( pr != null );

         // iterate to-many link consists of from pr to t
         fujaba__Success = false;
         fujaba__IterPrToT = pr.iteratorOfTasks ();

         while ( fujaba__IterPrToT.hasNext () )
         {
            try
            {
               t = (Task) fujaba__IterPrToT.next ();

               // check object t is really bound
               JavaSDM.ensure ( t != null );
               // iterate to-many link contains from this to e
               fujaba__Success = false;
               fujaba__IterThisToE = this.iteratorOfEmployees ();

               while ( fujaba__IterThisToE.hasNext () )
               {
                  try
                  {
                     e = (Employee) fujaba__IterThisToE.next ();

                     // check object e is really bound
                     JavaSDM.ensure ( e != null );
                     // destroy link consists of from t to pr
                     t.setProject (null);
                     // create link task from e to t
                     e.setTask (t);

                     // collabStat call
                     e.work ( t );

                     fujaba__Success = true;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false;
                  }
               }
               JavaSDM.ensure (fujaba__Success);

               fujaba__Success = true;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         JavaSDM.ensure (fujaba__Success);

         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;
   }

   public void removeYou()
   {
      this.removeAllFromEmployees ();
      this.removeAllFromManagers ();
      this.setProject (null);
   }
}


