/*
 * generated by Fujaba - CodeGen2
 */
package dpexamples.model;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import de.upb.tools.sdm.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Employee
{

   /**
    * <pre>
    *           0..n     contains     0..1
    * Employee ------------------------- Company
    *           employees               company
    * </pre>
    */
   public static final String PROPERTY_COMPANY = "company";

   @Property( name = PROPERTY_COMPANY, partner = Company.PROPERTY_EMPLOYEES, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Company company;

   @Property( name = PROPERTY_COMPANY )
   public boolean setCompany (Company value)
   {
      boolean changed = false;

      if (this.company != value)
      {
      
         Company oldValue = this.company;
         Employee source = this;
         if (this.company != null)
         {
            this.company = null;
            oldValue.removeFromEmployees (this);
         }
         this.company = value;

         if (value != null)
         {
            value.addToEmployees (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_COMPANY )
   public Company getCompany ()
   {
      return this.company;
   }

   /**
    * <pre>
    *           0..1     product     0..1
    * Employee ------------------------- Product
    *           employee               product
    * </pre>
    */
   public static final String PROPERTY_PRODUCT = "product";

   @Property( name = PROPERTY_PRODUCT, partner = Product.PROPERTY_EMPLOYEE, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Product product;

   @Property( name = PROPERTY_PRODUCT )
   public boolean setProduct (Product value)
   {
      boolean changed = false;

      if (this.product != value)
      {
      
         Product oldValue = this.product;
         Employee source = this;
         if (this.product != null)
         {
            this.product = null;
            oldValue.setEmployee (null);
         }
         this.product = value;

         if (value != null)
         {
            value.setEmployee (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PRODUCT )
   public Product getProduct ()
   {
      return this.product;
   }

   /**
    * <pre>
    *           0..1     task     0..1
    * Employee ------------------------- Task
    *           employee               task
    * </pre>
    */
   public static final String PROPERTY_TASK = "task";

   @Property( name = PROPERTY_TASK, partner = Task.PROPERTY_EMPLOYEE, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Task task;

   @Property( name = PROPERTY_TASK )
   public boolean setTask (Task value)
   {
      boolean changed = false;

      if (this.task != value)
      {
      
         Task oldValue = this.task;
         Employee source = this;
         if (this.task != null)
         {
            this.task = null;
            oldValue.setEmployee (null);
         }
         this.task = value;

         if (value != null)
         {
            value.setEmployee (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TASK )
   public Task getTask ()
   {
      return this.task;
   }

   public Product work (Task p1 )
   {
      boolean fujaba__Success = false;
      Product p = null;

      // story pattern 
      try 
      {
         fujaba__Success = false; 

         // check object p1 is really bound
         JavaSDM.ensure ( p1 != null );
         // create object p
         p = new Product ( );

         // create link product from this to p
         this.setProduct (p);

         // create link task from this to p1
         this.setTask (p1);

         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return p;
   }

   public void removeYou()
   {
      this.setCompany (null);
      this.setProduct (null);
      this.setTask (null);
   }
}


