/*
 * generated by Fujaba - CodeGen2
 */
package dpexamples.model;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Project
{

   /**
    * <pre>
    *           0..1     project     0..1
    * Project ------------------------- Company
    *           project               company
    * </pre>
    */
   public static final String PROPERTY_COMPANY = "company";

   @Property( name = PROPERTY_COMPANY, partner = Company.PROPERTY_PROJECT, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Company company;

   @Property( name = PROPERTY_COMPANY )
   public boolean setCompany (Company value)
   {
      boolean changed = false;

      if (this.company != value)
      {
      
         Company oldValue = this.company;
         Project source = this;
         if (this.company != null)
         {
            this.company = null;
            oldValue.setProject (null);
         }
         this.company = value;

         if (value != null)
         {
            value.setProject (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_COMPANY )
   public Company getCompany ()
   {
      return this.company;
   }

   /**
    * <pre>
    *           0..1     manages     0..1
    * Project ------------------------- Manager
    *           project               manager
    * </pre>
    */
   public static final String PROPERTY_MANAGER = "manager";

   @Property( name = PROPERTY_MANAGER, partner = Manager.PROPERTY_PROJECT, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Manager manager;

   @Property( name = PROPERTY_MANAGER )
   public boolean setManager (Manager value)
   {
      boolean changed = false;

      if (this.manager != value)
      {
      
         Manager oldValue = this.manager;
         Project source = this;
         if (this.manager != null)
         {
            this.manager = null;
            oldValue.setProject (null);
         }
         this.manager = value;

         if (value != null)
         {
            value.setProject (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_MANAGER )
   public Manager getManager ()
   {
      return this.manager;
   }

   /**
    * <pre>
    *           0..1     belongs_to     0..n
    * Project ------------------------- Presentation
    *           project               presentations
    * </pre>
    */
   public static final String PROPERTY_PRESENTATIONS = "presentations";

   @Property( name = PROPERTY_PRESENTATIONS, partner = Presentation.PROPERTY_PROJECT, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet presentations;

   @Property( name = PROPERTY_PRESENTATIONS )
   public boolean addToPresentations (Presentation value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.presentations == null)
         {
            this.presentations = new FHashSet ();

         }
      
         changed = this.presentations.add (value);
         if (changed)
         {
            value.setProject (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PRESENTATIONS )
   public boolean removeFromPresentations (Presentation value)
   {
      boolean changed = false;

      if ((this.presentations != null) && (value != null))
      {
      
         changed = this.presentations.remove (value);
         if (changed)
         {
            value.setProject (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PRESENTATIONS )
   public void removeAllFromPresentations ()
   {
   
      Presentation tmpValue;
      Iterator iter = this.iteratorOfPresentations ();

      while (iter.hasNext ())
      {
         tmpValue = (Presentation) iter.next ();
         this.removeFromPresentations (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_PRESENTATIONS )
   public boolean hasInPresentations (Presentation value)
   {
      return ((this.presentations != null) &&
              (value != null) &&
              this.presentations.contains (value));
   }

   @Property( name = PROPERTY_PRESENTATIONS )
   public Iterator iteratorOfPresentations ()
   {
      return ((this.presentations == null)
              ? FEmptyIterator.get ()
              : this.presentations.iterator ());
   }

   @Property( name = PROPERTY_PRESENTATIONS )
   public int sizeOfPresentations ()
   {
      return ((this.presentations == null)
              ? 0
              : this.presentations.size ());
   }

   /**
    * <pre>
    *           0..1     consists of     0..n
    * Project ------------------------- Task
    *           project               tasks
    * </pre>
    */
   public static final String PROPERTY_TASKS = "tasks";

   @Property( name = PROPERTY_TASKS, partner = Task.PROPERTY_PROJECT, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet tasks;

   @Property( name = PROPERTY_TASKS )
   public boolean addToTasks (Task value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.tasks == null)
         {
            this.tasks = new FHashSet ();

         }
      
         changed = this.tasks.add (value);
         if (changed)
         {
            value.setProject (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TASKS )
   public boolean removeFromTasks (Task value)
   {
      boolean changed = false;

      if ((this.tasks != null) && (value != null))
      {
      
         changed = this.tasks.remove (value);
         if (changed)
         {
            value.setProject (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TASKS )
   public void removeAllFromTasks ()
   {
   
      Task tmpValue;
      Iterator iter = this.iteratorOfTasks ();

      while (iter.hasNext ())
      {
         tmpValue = (Task) iter.next ();
         this.removeFromTasks (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_TASKS )
   public boolean hasInTasks (Task value)
   {
      return ((this.tasks != null) &&
              (value != null) &&
              this.tasks.contains (value));
   }

   @Property( name = PROPERTY_TASKS )
   public Iterator iteratorOfTasks ()
   {
      return ((this.tasks == null)
              ? FEmptyIterator.get ()
              : this.tasks.iterator ());
   }

   @Property( name = PROPERTY_TASKS )
   public int sizeOfTasks ()
   {
      return ((this.tasks == null)
              ? 0
              : this.tasks.size ());
   }

   public void removeYou()
   {
      this.setCompany (null);
      this.setManager (null);
      this.removeAllFromPresentations ();
      this.removeAllFromTasks ();
   }
}


