/*
 * generated by Fujaba - CodeGen2
 */
package dpexamples.model;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import de.upb.tools.sdm.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import de.upb.tools.pcs.PropertyChangeClient; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;


public class Sensor implements PropertyChangeClient
{
	protected final PropertyChangeSupport listeners = new PropertyChangeSupport(this);

	public void addPropertyChangeListener(PropertyChangeListener listener)
	{
		getPropertyChangeSupport().addPropertyChangeListener(listener);
	}

	public void removePropertyChangeListener(PropertyChangeListener listener)
	{
		getPropertyChangeSupport().removePropertyChangeListener(listener);
	}

	public void addPropertyChangeListener(String property, PropertyChangeListener listener)
	{
		getPropertyChangeSupport().addPropertyChangeListener(property, listener);
	}

	public void removePropertyChangeListener(String property, PropertyChangeListener listener)
	{
		getPropertyChangeSupport().removePropertyChangeListener(property, listener);
	}

	public PropertyChangeSupport getPropertyChangeSupport()
	{
		return listeners;
	}


   /**
    * <pre>
    *           0..1     contains     0..n
    * Sensor ------------------------- Sensor
    *           parent               children
    * </pre>
    */
   public static final String PROPERTY_CHILDREN = "children";

   @Property( name = PROPERTY_CHILDREN, partner = Sensor.PROPERTY_PARENT, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FPropHashSet children;

   @Property( name = PROPERTY_CHILDREN )
   public boolean addToChildren (Sensor value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.children == null)
         {
            this.children = new FPropHashSet (this, PROPERTY_CHILDREN);

         }
      
         changed = this.children.add (value);
         if (changed)
         {
            value.setParent (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CHILDREN )
   public boolean removeFromChildren (Sensor value)
   {
      boolean changed = false;

      if ((this.children != null) && (value != null))
      {
      
         changed = this.children.remove (value);
         if (changed)
         {
            value.setParent (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CHILDREN )
   public void removeAllFromChildren ()
   {
   
      Sensor tmpValue;
      Iterator iter = this.iteratorOfChildren ();

      while (iter.hasNext ())
      {
         tmpValue = (Sensor) iter.next ();
         this.removeFromChildren (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_CHILDREN )
   public boolean hasInChildren (Sensor value)
   {
      return ((this.children != null) &&
              (value != null) &&
              this.children.contains (value));
   }

   @Property( name = PROPERTY_CHILDREN )
   public Iterator iteratorOfChildren ()
   {
      return ((this.children == null)
              ? FEmptyIterator.get ()
              : this.children.iterator ());
   }

   @Property( name = PROPERTY_CHILDREN )
   public int sizeOfChildren ()
   {
      return ((this.children == null)
              ? 0
              : this.children.size ());
   }

   public static final String PROPERTY_NAME = "name";

   @Property( name = PROPERTY_NAME, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private String name;

   @Property( name = PROPERTY_NAME )
   public void setName (String value)
   {
      if ( ! JavaSDM.stringEquals (this.name, value))
      {
         String oldValue = this.name;
         this.name = value;
         getPropertyChangeSupport().firePropertyChange(PROPERTY_NAME, oldValue, value);
      }
   }

   @Property( name = PROPERTY_NAME )
   public String getName ()
   {
      return this.name;
   }

   public static final String PROPERTY_NUMBER = "number";

   @Property( name = PROPERTY_NUMBER, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int number;

   @Property( name = PROPERTY_NUMBER )
   public void setNumber (int value)
   {
      if ( this.number != value )
      {
         int oldValue = this.number;
         this.number = value;
         getPropertyChangeSupport().firePropertyChange(PROPERTY_NUMBER, oldValue, value);
      }
   }

   @Property( name = PROPERTY_NUMBER )
   public int getNumber ()
   {
      return this.number;
   }

   /**
    * <pre>
    *           0..n     contains     0..1
    * Sensor ------------------------- Sensor
    *           children               parent
    * </pre>
    */
   public static final String PROPERTY_PARENT = "parent";

   @Property( name = PROPERTY_PARENT, partner = Sensor.PROPERTY_CHILDREN, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Sensor parent;

   @Property( name = PROPERTY_PARENT )
   public boolean setParent (Sensor value)
   {
      boolean changed = false;

      if (this.parent != value)
      {
      
         Sensor oldValue = this.parent;
         Sensor source = this;
         if (this.parent != null)
         {
            this.parent = null;
            oldValue.removeFromChildren (this);
         }
         this.parent = value;

         if (value != null)
         {
            value.addToChildren (this);
         }
            getPropertyChangeSupport().firePropertyChange(PROPERTY_PARENT, oldValue, value);
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PARENT )
   public Sensor getParent ()
   {
      return this.parent;
   }

   public void removeYou()
   {
      this.removeAllFromChildren ();
      this.setParent (null);
   }
}


