package dpexamples.day3;

import java.util.ArrayList;
import java.util.List;

public class House {
	
	
	List<AlarmDevice> alarms = new ArrayList<AlarmDevice>();
	// AlarmDevice alarmDevice;
	
	public void alarm() {
		for (AlarmDevice a : alarms) {
			if (a.active) {
				a.alarm();
				return;
			}
		}
	}
	
	public static void main(String[] args) {
		House house = new House();
		house.init();
		for (int i = 0; i < 1; ++i) {
			house.alarm();			
		}
	}

	private void init() {
		FlashLight a1 = new FlashLight();
		alarms.add(a1);
		Siren a2 = new Siren();
		//a2.active = true;
		alarms.add(a2);
		MailNotification a3 = new MailNotification();
		alarms.add(a3);
	}
}

abstract class AlarmDevice {
	boolean active;
	void alarm() {
	}
}

class Siren extends AlarmDevice {

	void alarm() {
		super.alarm();
		System.out.println("Siren on!");
	}
	
}

class FlashLight extends AlarmDevice {

	void alarm() {
		super.alarm();
		System.out.println("Flashlight on!");
	}
	
}

class MailNotification extends AlarmDevice {

	void alarm() {
		super.alarm();
		System.out.println("Sent an email to my blackberry!");
	}
	
}