package dpexamples.day4;

import java.io.File;
import java.util.List;
import java.util.ArrayList;

public abstract class AbstractFile {
	
	File file;
	AbstractFile parent;
	List<AbstractFile> contains;
    
    public boolean isDirectory() {
    	return file.isDirectory();
    }
    
    public List<AbstractFile> getChildren() {
    	if (contains == null) {
        	contains = new ArrayList<AbstractFile>();
        	File[] listFiles = file.listFiles();
        	for (File f : listFiles) {
                if (f.isDirectory()) {
                    contains.add(new Directory(f));
                } else {
                    contains.add(new RegularFile(f));
                }
            }    		
    	}
    	return contains;
    	
    }
	
	long getSize() {
		return file.length();
	}

	AbstractFile(File file) {
		this.file = file;
	}

	public String getName() {
		return file.getName();
	}
	
	void add(AbstractFile af) {
		throw new UnsupportedOperationException("read only!");
    }
	
    void accept(FileVisitor v) {
    	if (this instanceof RegularFile)
    	v.visit((RegularFile) this);
    	if (this instanceof Directory)
        	v.visit((Directory) this);
    	// else do nothing
    }
}
