package dpexamples.day4;

public class House {
	
	
	AlarmDevice alarmDevice;
    int dangerLevel = 50;
	
	public void alarm() {
		alarmDevice.alarm();
		AlarmDevice next = alarmDevice.update(dangerLevel);
		if (next != null) {
			alarmDevice = next;
		}
	}
	
	public static void main(String[] args) {
		House house = new House();
		house.init();
		/* for (int i = 0; i < 1000; ++i) {
			house.alarm();			
		} */
		
		// wait some time...
		// something happens for the sensor
		//Sensor s = Sensor.getInstance();
		//s.sensorChanged();
	}

	private void init() {
		FlashLight fl = AlarmDeviceFactory.createFlashlight();
		Siren siren = AlarmDeviceFactory.createSiren();
		AlarmDevice mn = AlarmDeviceFactory.createMailNotification("ruben");

        mn.up = fl; fl.down = mn;
        fl.up = siren; siren.down = fl;

		alarmDevice = mn;
		
		Sensor s1 = new Sensor();
		Sensor s2 = new Sensor();
		s1.attach(fl);
		s1.attach(siren);
		s2.attach(mn);
		s2.attach(AlarmDeviceFactory.createFlashlight());
		
		
		/// wait..
		// chang sensors
		
	}
}

class AlarmDeviceFactory {
	static Siren createSiren() {
		return new Siren();
	}
	static FlashLight createFlashlight() {
		return new FlashLight();
	}
	static AlarmDevice createMailNotification(String email) {
		MailNotification mn = new MailNotificationImpl();
		mn.email = email;
		return mn;
	}
}

abstract class AlarmDevice implements Sensor.SensorObserver {
    AlarmDevice up;
    AlarmDevice down;
    static int level = 50;
	void alarm() {
	}
	AlarmDevice update(int dangerLevel) {
	    if (dangerLevel > 60) {
            return up;
        } else if (dangerLevel < 20) {
            return down;
        }
        return this;
	}
	@Override
	public void temperatureUpdated(Sensor s) {
		// oh! the sensor changed! lets have a look!

		if (s.getTemperature() > 40) {
			alarm();
		}
		
	}
	
}

class Siren extends AlarmDevice {

	void alarm() {
		System.out.println("Siren on!");
	}	
}

class FlashLight extends AlarmDevice {

	void alarm() {
		System.out.println("Flashlight on!");
	}	
}

abstract class MailNotification extends AlarmDevice {

	String email;
	void alarm() {
		System.out.println("Sent an email to my blackberry!");
	}

	@Override
	public void temperatureUpdated(Sensor s) {
		if (s.getTemperature() > 100) {
			s.detach(this);
		}
	}		
}

class MailNotificationImpl extends MailNotification {
	// real smtp implementation
}