package dpexamples.day4;

import java.io.File;

public abstract class ImageConverter {

    public static void main(String[] args) {
        new JPEG2PNGConverter().run();
        Image image = new Image();
        
        ImageTransformer it = new ChangeColorDepthTransformer( new InvertImageTransformer( new JPEGCompressionTransformer () ) );
        
        it.transform(image);
        it.write();
        
        
        // new XXXX.transform();
        
    }

    public final void run() {
        File file = selectFile();
        Image image = openFile(file);
        convertToBitmap(image);
        transform(image);
        write(image, file);
    }

    // the same for all subclasses
    private File selectFile() {
        return null;
    }

    // invariant or not?
    protected void write(Image image, File file) {
    }

    // might vary - alternative patterns?
    protected Image transform(Image image) {
    	return image;
    }

    protected abstract void convertToBitmap(Image image);

    private Image openFile(File file) {
        return new Image();
    }

}

abstract class ImageTransformer {
	
	ImageTransformer next;

	abstract void transform(Image image);
	public void write() {}
}

class ChangeColorDepthTransformer extends ImageTransformer {

	public ChangeColorDepthTransformer(ImageTransformer next) {
		this.next = next;
	}
	@Override
	public void transform(Image image) {
		// change the color
		if (next != null) {
			next.transform(image);
		}
		
	}
	
}

class JPEGCompressionTransformer extends ImageTransformer {

	@Override
	public void transform(Image image) {
		// TODO Auto-generated method stub
		if (next != null) {
			next.transform(image);
		}
		
	}
	
}

class InvertImageTransformer extends ImageTransformer {

	public InvertImageTransformer(ImageTransformer next) {
		this.next = next;
	}
	@Override
	public void transform(Image image) {
		// TODO Auto-generated method stub
		if (next != null) {
			next.transform(image);
		}
		
	}
	
}

class JPEG2PNGConverter extends ImageConverter {

	@Override
	protected void convertToBitmap(Image image) {
		// do it somehow
	}

	@Override
	protected void write(Image image, File file) {
		// write a PNG file with the proper extension
	}
	
}

class InvertConverter extends ImageConverter {
	@Override
	protected void convertToBitmap(Image image) {
		// do it somehow
	}

	@Override
	protected Image transform(Image image) {
		// TODO Auto-generated method stub
		return super.transform(image);
	}
	
	
}

class Image {

}