
package dpexamples.day4;

import java.util.ArrayList;
import java.util.List;

// sensor must not know anything about alarmDevices

public class Sensor {
	
    private static Sensor ourInstance = new Sensor();

    private int temperature = 120;
    private int powerLevel;
    
    
    List<SensorObserver> observers = new ArrayList<SensorObserver>();
    
    public void sensorChanged() {
    	for (SensorObserver so : observers) {
    		so.temperatureUpdated(this);
    	}
    }
    
    /**
     * might be generated very fast - please return immediately
     * @author ruben
     *
     */
    interface SensorObserver {
    	void temperatureUpdated(Sensor source);
    }

	public void attach(SensorObserver s) {
		observers.add(s);	
	}
	
	public void detach(SensorObserver s) {
		observers.remove(s);
	}

	public int getTemperature() {
		// TODO Auto-generated method stub
		return temperature;
	}
}
