package dpexamples.day5;

public class ApplicationWithPlugin {

    AbstractPlugin plugin;

    public ApplicationWithPlugin(String pluginClassName) throws Exception {
        String packageName = getClass().getPackage().getName();
        System.out.println("we are in package: " + packageName);
        String fullPluginClassName = packageName + "." + pluginClassName;
        System.out.println("we should load plugin: " + fullPluginClassName);
        Object o = Class.forName(fullPluginClassName).newInstance();
    }

    public static void main(String[] args) throws Exception {
        new ApplicationWithPlugin("HelloPlugin").run();
    }

    private void run() {
        plugin.sayHello();
    }
}

interface AbstractPlugin {
    void sayHello();
}
