package dpexamples.day5;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.util.List;
import java.util.ArrayList;

public class IncrementApplication extends JFrame {

    public int counter; // might be a (mutable) object
    public List<Command> commands = new ArrayList<Command>();

    public void incrementCounter() {
        counter++;
        System.out.println("counter = " + counter);
    }

    private void run() {
        JButton button = new JButton("Increment!");
        getContentPane().add(button);
        button.addActionListener(new IncrementAction());
        pack();
        setVisible(true);
    }

    private class IncrementAction extends AbstractAction {
        public void actionPerformed(ActionEvent e) {
            // execute the operation here
            incrementCounter();
        }
    }

    public static void main(String[] args) {
        new IncrementApplication().run();
    }
}

interface Command {
    void execute();
}