package dpexamples.day5.drawapp.model;

import java.awt.*;

public abstract class AbstractGraphic implements Cloneable {

    protected int x1, x2, y1, y2;

    public void setCoordinates(int x1, int y1, int x2, int y2) {
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
    }

    public abstract void draw(Graphics2D g);

    @Override
    public AbstractGraphic clone() {
        try {
            return (AbstractGraphic) super.clone();
        } catch (CloneNotSupportedException e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[x1="+x1+",y1="+y1+",x2="+x2+",y2="+y2+"]";
    }
}
