package dpexamples.day5.drawapp.model;

import dpexamples.day5.drawapp.model.Line;

import java.util.Collection;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.awt.*;

public class DrawModel extends AbstractGraphic {

    private Collection<AbstractGraphic> graphics = new ArrayList<AbstractGraphic>();

    // Map of one instance per class
    private Map<Class, AbstractGraphic> prototypes = new HashMap<Class, AbstractGraphic>();

    public DrawModel() {
        addPrototype(new Box());
        addPrototype(new Line());
    }

    private void addPrototype(AbstractGraphic prototype) {
        prototypes.put(prototype.getClass(), prototype);
    }

    public AbstractGraphic getPrototype(Class prototypeClass) {
        return prototypes.get(prototypeClass);
    }

    // #PATTERN# ?
    public void draw(Graphics2D g) {
        for (AbstractGraphic graphic : graphics) {
            graphic.draw(g);
        }
    }

    public void addGraphic(AbstractGraphic prototype) {
        graphics.add(prototype);
        
    }
}
