package dpexamples.day5.drawapp.operations;

public abstract class AbstractOperation implements Cloneable {

    public abstract void execute();
    public void undo() {
        throw new UnsupportedOperationException();
    }
    public void redo() {
        execute();
    }

    public AbstractOperation clone() {
        try {
            return (AbstractOperation) super.clone();
        } catch (CloneNotSupportedException e) {
            throw new InternalError();
        }
    }
}
